<template>
  <div style="margin: 3rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton :offsetArrow="21" :spanTitle="2" title="Regresar" v-on:clickEvent="modalReturnBtn = true" style="margin-bottom:2.5rem"></ReturnButton>
      <el-row :gutter="20">
      <!-- BUSCADOR --> 
        <el-col :span="6" :offset="18">
          <app-search-filter v-model="textSearch"></app-search-filter>
        </el-col>  
      </el-row>
    </header>

   <!-- COMPONENTE TITULO -->
    <div style="margin:3rem 6rem">
      <app-title :Title=" 'RECEPCIÓN DE ' + (itemTelevisa.originalTitle).toUpperCase()"  bgColor="background-color: #818181 !important"> </app-title>
    </div>

    <!-- CARDS  -->
      <el-main style="margin:3rem 8rem">
        <el-row>
          <el-col >
            <el-collapse class="recept-accordion" style="margin-bottom:3rem">
              <el-collapse-item class="recept-accordion-child">
                <template slot="title">
                  <el-row>
                    <el-col :span="20">
                      <div class="recept-accordion-title">
                        <i class="el-icon-caret-right"></i>
                        <div class="box-title">
                          <span class="title-accordion">{{  itemTelevisa.originalTitle }}</span>
                          <span class="text-bold text-red" style="font-size:14px; margin-left:2rem">{{itemTelevisa.infoSupport[0].showreplace}}</span>
                        </div>
                      </div>
                      <div class="recept-accordion-status">
                        <el-radio v-model="itemTelevisa.infoSupport[0].radio" label="Pendiente" > Pendiente </el-radio>
                        <el-radio v-model="itemTelevisa.infoSupport[0].radio" label="Recibido" > Recibido </el-radio>
                      </div>
                    </el-col>
                    <el-col :span="4" style="text-align: center; margin-top: 20px;">
                      <img src="../../../../assets/images/borrador-rojo.svg" @click="ModalClean" >
                    </el-col>
                  </el-row>
                </template>
                <div>

                  <el-row style="margin: 12px 0;" type="flex" align="middle">
                    <el-col :span="6" class="subtitles-chapter-form">
                      Fecha de llegada:
                    </el-col>
                    <el-col :span="6">						
                      <el-date-picker style="width: 100%"
                        v-model="itemTelevisa.infoSupport[0].arrivalDate" type="date" format="dd/MM/yyyy" value-format="timestamp">
                      </el-date-picker>
                    </el-col>
                  </el-row>

                  <el-row style="margin: 12px 0;" type="flex" align="middle">
                    <el-col :span="6" class="subtitles-chapter-form">
                      Soporte de Llegada:
                    </el-col>
                    <el-col :span="6">
                      <app-select v-model="itemTelevisa.infoSupport[0].support" :filterArray="methodsArrival"  ></app-select>
                    </el-col>
                  </el-row>

                  <el-row style="margin: 12px 0;" type="flex" align="middle">
                    <el-col :span="6" class="subtitles-chapter-form">
                      Modo de envío:
                    </el-col>
                    <el-col :span="6">
                      <app-select v-model="itemTelevisa.infoSupport[0].shippingMode" :filterArray="allShipping"></app-select>
                    </el-col>
                  </el-row>
                 <el-row style="margin: 12px 0;" type="flex" align="middle">
                    <el-col :span="6" class="subtitles-chapter-form">
                      Número de Guía:
                    </el-col>
                    <el-col :span="6">
                      <el-input v-model="itemTelevisa.infoSupport[0].guideNumber" :disabled="chooseGuideNumber(itemTelevisa.infoSupport[0].arrivalDate, itemTelevisa.infoSupport[0].support, itemTelevisa.infoSupport[0].shippingMode)"></el-input>
                    </el-col>
                  </el-row>

                </div>
              </el-collapse-item>
            </el-collapse>
         </el-col>
      </el-row>
    </el-main>

      <section style="margin:5rem 6rem 4rem 6rem">      
        <el-row>
          <el-col :span="2" :offset="17">
            <el-button  size="medium" v-on:click="modalCancelButton = true"  type="primary" plain>CANCELAR </el-button>                          
          </el-col>
          <el-col :span="1" :offset="2">
            <el-button size="medium" @click="enterNewOrder" type="primary"> REGISTRAR </el-button>  
          </el-col>
        </el-row>  
      </section>

    <!-- Modal botón copiar-->
     <app-modal :show-dialog.sync="modalCopy" v-if="modalCopy"  nameClass="dialog-orange" :rutImg="require(`../../../../assets/images/suspicious.svg`)" sizeImg="80px" textBold="¡Un momento!" typeBtn1="primary"
     :parrafo="'¿Quieres <strong>'+  copy   + '</strong> la informacion en todos los capítulos? ' "
      classBtn1="border-orange" btn1="SI, COPÍAR" btn2="CANCELAR"  @btnEvent="btnCopiar" v-on:eventBtn="modalCopy = false">
    </app-modal>

      <!-- Modal botón ingresar-->
    <!-- :parrafo="'Se guardó la información de los capítulos de <strong>' + itemSupportMat.originalTitle + ' <strong>'" -->

    <AppModalSuccess :show-dialog.sync="enterSupportModal" v-if="enterSupportModal" 
    :parrafo="'Se guardó la información de la recepción de los capítulos'"
      btn1="ACEPTAR" @btnEvent="enterSupportModal = false" v-on:btnEvent="returnPage" >
    </AppModalSuccess>

    <!-- Modal botón cancelar -->
    <AppModalDanger :show-dialog.sync="modalCancelButton" v-if="modalCancelButton"  v-on:btnEvent="returnPage"  @btnEvent="modalCancelButton = false" v-on:eventBtn="modalCancelButton = false">
    </AppModalDanger>

    <!-- Modal botón de retroceder RETURNBUTTON -->
    <AppModalDanger parrafo="Si te vas sin guardar, la información se perderá." :show-dialog.sync="modalReturnBtn" v-if="modalReturnBtn"  v-on:btnEvent="returnPage"  @btnEvent="modalReturnBtn = false" v-on:eventBtn="modalReturnBtn = false">
    </AppModalDanger> 

    <!-- Modal del borrardor -->
    <app-modal :show-dialog.sync="clean" v-if="clean" nameClass="dialog-red" :rutImg="require(`../../../../assets/images/alerta.svg`)" sizeImg="65px" textBold="¡Un momento!"
      :parrafo="'¿Seguro de que quieres borrar la informacion ingresada?'" classBtn1="border-red" typeBtn1="danger" btn1="SÍ, BORRAR" btn2="CANCELAR" @btnEvent="borrarInfo" v-on:eventBtn="clean = false" >
    </app-modal>


  </div>
</template>

<script>
  import ReturnButton from '@/components/ReturnButton.vue'
  import Title from '@/components/Title.vue'  
  import SearchFilter from '@/components/searchFilter.vue'
  import { HTTP } from '../../../../main.js' 
  import Select from '@/components/AppSelect.vue'
  import AppModal from '@/components/AppModal.vue'
  import AppModalSuccess from '@/components/AppModalSuccess.vue'
  import AppModalDanger from '@/components/AppModalDanger.vue'
  import { modifyText } from '../../../../utils/modifyText.js'


  export default {
    components: {
      ReturnButton,
      AppModalSuccess,
      AppModalDanger,
     'app-search-filter': SearchFilter, 
     'app-title': Title,
     'app-select': Select,
     'app-modal': AppModal
    },
    data() {
      return {
        clean: false,
        modalReturnBtn: false,
        stateBtnSup: JSON.parse(this.$localStorage.get("stateBtnSup")), 
        itemStorage: {},
        enterSupportModal: false,
        modalCancelButton: false,
        indexStorage: 0,
        textSearch: '',
        idSupportMat: JSON.parse(this.$localStorage.get("idSupportMat")), 
        itemTelevisa: JSON.parse(this.$localStorage.get("itemTelevisa")), 
        // itemSupportMat: [],
        season: [],
        selectItems: [],
        textarea3: '',
        checked: false,
        temporada: '',
        seasonFilterByTemp: {},
        // radio: '',
        modalCopy: false,
        copy: 'copiar',
        indexTemp: 0,
        indexItemCap: 0,
        itemCap: {}, 
        // televisa
        allShipping: [],
        methodsArrival: [],
        support: [],
      }
    },
    created () {
      this.getSupportMaterials();  
      this.getTablesSupport() 
    },
    methods: { 
      getTablesSupport () {
        HTTP.get('tables/tableName/shippingMethods')
          .then(res => {
            this.allShipping = res.data.table[0].types
            this.methodsArrival = res.data.table[0].description
          })
        .catch(err => {
          console.log(err)
        });   
      },

      ModalClean() {
        this.clean = true
      },
      enterNewOrder () {
        this.itemTelevisa.infoSupport[0].replacement = false
        // if( this.itemTelevisa.infoSupport[0].arrivalDate == '' && this.itemTelevisa.infoSupport[0].shippingMode == '' && this.itemTelevisa.infoSupport[0].support == '' && this.itemTelevisa.infoSupport[0].guideNumber == '') {
        if(this.itemTelevisa.infoSupport[0].radio == 'Pendiente' || this.itemTelevisa.infoSupport[0].radio == '' || this.itemTelevisa.infoSupport[0].radio == undefined) {
          this.itemTelevisa.colorButton = 'info'
          this.itemTelevisa.stateButton = 'PENDIENTE'
        } else {
          this.itemTelevisa.colorButton = 'success'
          this.itemTelevisa.stateButton = 'RECIBIDO'
        }

        HTTP.patch(`materials/update/${this.itemTelevisa.__id}` , [
          { propName: "stateBtnSupport", value: this.itemTelevisa.stateButton },
          { propName: "colorBtnSupport", value: this.itemTelevisa.colorButton }, 
          // { propName: "storageMat", value: this.itemTelevisa.storageMat },  
          { propName: "infoSupport", value: this.itemTelevisa.infoSupport },  
          ])
        .then(res => {
          res.data;
          this.enterSupportModal = true
        })
        .catch(err => console.log(err))
     
      },   
      returnPage() {
        this.$router.push({name: 'receptionTelevisa'})
      },
      getSupportMaterials() {
        // this.itemSupportMat = this.itemTelevisa
        // this.support = this.itemTelevisa.support
        if(!(this.itemTelevisa.infoSupport.length > 0)){
          console.log('esta vacío')
          let objetoP = {
            radio: 'Pendiente',
            stateStorage: 'Pendiente',
            arrivalDate: '',
            guideNumber: '',
            shippingMode: '',
            copyBackup: '',
            dateOfCopy: '',
            storages: '',
            videoteca: '',
            replacement: (this.itemTelevisa.stateBtnSupport == 'INCOMPLETO')?true:false,
            showreplace: (this.itemTelevisa.stateBtnSupport == 'INCOMPLETO')?'REPOSICIÓN':'',
            supportMaterial:  [
              {
                typeStorage: "",
                codeDisk: ""
              }
            ],
            replacementStorage: false,
            statusMaterial: 1,
            statusStorage: 1,
            reposicion: []
          }

          this.itemTelevisa.infoSupport.push(objetoP)
        } else {
          if(this.itemTelevisa.stateBtnSupport == 'INCOMPLETO') {
            if(this.itemTelevisa.infoSupport[0].replacement == true &&
              this.itemTelevisa.infoSupport[0].replacementStorage == true ) {
              console.log('entree')
              let repositionObj = {
                arrivalDate: this.itemTelevisa.infoSupport[0].arrivalDate,
                shippingMode: this.itemTelevisa.infoSupport[0].shippingMode,
                support: this.itemTelevisa.infoSupport[0].support,
                guideNumber: this.itemTelevisa.infoSupport[0].guideNumber,
                supportMaterial: this.itemTelevisa.infoSupport[0].supportMaterial,
                copyBackup: this.itemTelevisa.infoSupport[0].copyBackup,
                dateOfCopy: this.itemTelevisa.infoSupport[0].dateOfCopy,
                storages: this.itemTelevisa.infoSupport[0].storages,
                videoteca: this.itemTelevisa.infoSupport[0].videoteca
              }
              this.itemTelevisa.infoSupport[0].reposicion.push(repositionObj)
              this.itemTelevisa.infoSupport[0].arrivalDate = ''
              this.itemTelevisa.infoSupport[0].shippingMode = ''
              this.itemTelevisa.infoSupport[0].support = ''
              this.itemTelevisa.infoSupport[0].guideNumber = ''
              this.itemTelevisa.infoSupport[0].supportMaterial = [{typeStorage: "", codeDisk: ""}]
              this.itemTelevisa.infoSupport[0].copyBackup = ''
              this.itemTelevisa.infoSupport[0].dateOfCopy = ''
              this.itemTelevisa.infoSupport[0].storages = ''
              this.itemTelevisa.infoSupport[0].videoteca = ''
            
            } else {
              this.borrarInfo()
            }
            
          }
        }
      },
      borrarInfo() {
        this.itemTelevisa.infoSupport[0].arrivalDate = ''
        this.itemTelevisa.infoSupport[0].shippingMode = ''
        this.itemTelevisa.infoSupport[0].support = ''
        this.itemTelevisa.infoSupport[0].radio = 'Pendiente'
        this.itemTelevisa.infoSupport[0].guideNumber = ''
        this.clean = false
      },
      chooseGuideNumber(arrivalDate, arrivalSupport, shippingMode) {
        if((!arrivalDate || arrivalDate == '') || (!arrivalSupport || arrivalSupport == '') || (!shippingMode ||shippingMode == '')){
          return true
        } else {
          return false
        }
      }
    },
    computed: {
      isShowTextReplacement() {
        if(this.itemTelevisa && this.itemTelevisa.infoSupport.length > 0) {
          return this.itemTelevisa.infoSupport[0].replacement
        } else {
          return false
        }
      }
    }
}
</script>


